## crypto-policies 20190816git

=== Makefile ===
VERSION=$(shell git log -1|grep commit|cut -f 2 -d ' '|head -c 7)
DIR?=/usr/share/crypto-policies
BINDIR?=/usr/bin
MANDIR?=/usr/share/man
CONFDIR?=/etc/crypto-policies
DESTDIR?=
MAN7PAGES=crypto-policies.7
MAN8PAGES=update-crypto-policies.8 fips-finish-install.8 fips-mode-setup.8
SCRIPTS=update-crypto-policies fips-finish-install fips-mode-setup

all: build

build: $(MAN7PAGES) $(MAN8PAGES)
	mkdir -p output
	python/build-crypto-policies.py --reloadcmds policies output

install: $(MANPAGES)
	mkdir -p $(DESTDIR)$(MANDIR)
	mkdir -p $(DESTDIR)$(MANDIR)/man7
	mkdir -p $(DESTDIR)$(MANDIR)/man8
	mkdir -p $(DESTDIR)$(BINDIR)
	install -p -m 644 $(MAN7PAGES) $(DESTDIR)$(MANDIR)/man7
	install -p -m 644 $(MAN8PAGES) $(DESTDIR)$(MANDIR)/man8
	install -p -m 755 $(SCRIPTS) $(DESTDIR)$(BINDIR)
	mkdir -p $(DESTDIR)$(DIR)/
	install -p -m 644 default-config $(DESTDIR)$(DIR)
	install -p -m 644 output/reload-cmds.sh $(DESTDIR)$(DIR)
	for f in $$(find output -name '*.txt') ; do d=$$(dirname $$f | cut -f 2- -d '/')  ; install -p -m 644 -D -t $(DESTDIR)$(DIR)/$$d $$f ; done
	for f in $$(find policies -name '*.p*') ; do d=$$(dirname $$f)  ; install -p -m 644 -D -t $(DESTDIR)$(DIR)/$$d $$f ; done
	for f in $$(find python -name '*.py') ; do d=$$(dirname $$f) ; install -p -m 644 -D -t $(DESTDIR)$(DIR)/$$d $$f ; done
	chmod 755 $(DESTDIR)$(DIR)/python/update-crypto-policies.py
	chmod 755 $(DESTDIR)$(DIR)/python/build-crypto-policies.py

check:
	python/build-crypto-policies.py --test --flat policies tests/outputs
	tests/openssl.pl
	tests/gnutls.pl
	tests/nss.pl
	tests/java.pl
	tests/krb5.py
	top_srcdir=. tests/update-crypto-policies.sh

reset-outputs:
	@rm -rf tests/outputs/*
	echo "Outputs were reset. Run make check to re-generate, and commit the output."

clean:
	rm -f $(MAN7PAGES) $(MAN8PAGES) *.?.xml
	rm -rf output

%: %.txt
	asciidoc.py -v -d manpage -b docbook $<
	xsltproc --nonet -o $@ /usr/share/asciidoc/docbook-xsl/manpage.xsl $@.xml

dist:
	rm -rf crypto-policies && git clone . crypto-policies && rm -rf crypto-policies/.git/ && tar -czf crypto-policies-git$(VERSION).tar.gz crypto-policies && rm -rf crypto-policies

test-install:
	current_policy="$$(update-crypto-policies --show)" ; \
	if [ -z "$$current_policy" ] ; then exit 1; fi ; \
	test_policy=LEGACY ; \
	if [ "$$current_policy" = LEGACY ] ; then test_policy=DEFAULT ; fi ; \
	update-crypto-policies --set $$test_policy || exit $$? ; \
	grep -q $$test_policy $(CONFDIR)/config || exit $$? ; \
	ls -l $(CONFDIR)/back-ends/ | grep -q $$current_policy && exit 2 ; \
	ls -l $(CONFDIR)/back-ends/ | grep -q $$test_policy || exit $$? ; \
	update-crypto-policies --is-applied | grep -q "is applied" || exit $$? ; \
	update-crypto-policies --set $$current_policy || exit $$? ; \
	ls -l $(CONFDIR)/back-ends/ | grep -q $$test_policy && exit 3 ; \
	ls -l $(CONFDIR)/back-ends/ | grep -q $$current_policy || exit $$? ; \
	update-crypto-policies --is-applied | grep -q "is applied" || exit $$?

test-fips-setup:
	CONFDIR=$(CONFDIR) ./tests/test-fips-setup.sh

=== debian/changelog ===
crypto-policies (20190816git-1) unstable; urgency=medium

  * Initial release (Closes: #935636)
    - note: upstream releases per branch and not add release tags, so I just
      specify upstream version as <date>git, like 20190816git

 -- Hideki Yamane <henrich@debian.org>  Sat, 24 Aug 2019 21:29:22 +0900

=== debian/control ===
Source: crypto-policies
Section: utils
Priority: optional
Maintainer: Hideki Yamane <henrich@debian.org>
Build-Depends: debhelper (>= 12~), debhelper-compat (= 12),
               asciidoc-base, xsltproc, docbook-xsl, docbook-xml,
               openssl,
               gnutls-bin (>= 3.6.0),
               bind9,
#              krb5check, (not packaged yet)
               openjdk-11-jdk-headless | java-sdk-headless,
               libfile-pushd-perl, libfile-which-perl,
Standards-Version: 4.4.0
Homepage: https://gitlab.com/redhat-crypto/fedora-crypto-policies/
Vcs-Browser: https://salsa.debian.org/debian/cypto-policies
Vcs-Git: https://salsa.debian.org/debian/cypto-policies.git
Rules-Requires-Root: no

Package: crypto-policies
Architecture: all
Depends: ${misc:Depends}, python3,
Description: unify the crypto policies used by different applications and libraries
 "crypto-policies" is a utility to unify the crypto policies used by different
 applications and libraries. The current implementations works by setting the
 desired policy in /etc/crypto-policies/config. After this file is changed
 the script 'update-crypto-policies' should be executed, and the new policies
 will activate.
 .
 The supported back ends are:
  - GnuTLS
  - OpenSSL
  - NSS
  - BIND9
  - libkrb5
  - OpenSSH
  - Java (OpenJDK)
  - libssh
  - libreswan

## crypto-policies 20251128.git19878fe

=== Makefile ===
--- 
+++ 
@@ -3,10 +3,24 @@
 BINDIR?=/usr/bin
 MANDIR?=/usr/share/man
 CONFDIR?=/etc/crypto-policies
+LIBEXECDIR?=/usr/libexec
+UNITDIR?=/usr/lib/systemd/system
 DESTDIR?=
 MAN7PAGES=crypto-policies.7
-MAN8PAGES=update-crypto-policies.8 fips-finish-install.8 fips-mode-setup.8
-SCRIPTS=update-crypto-policies fips-finish-install fips-mode-setup
+MAN8PAGES=update-crypto-policies.8
+SCRIPTS=update-crypto-policies
+LIBEXEC_SCRIPTS=fips-crypto-policy-overlay fips-setup-helper
+UNITS=fips-crypto-policy-overlay.service
+NUM_PROCS = $$(getconf _NPROCESSORS_ONLN)
+PYVERSION = -3
+DIFFTOOL?=meld
+ASCIIDOC?=asciidoc
+XSLTPROC?=xsltproc
+ifneq ("$(wildcard /usr/lib/python*/*/asciidoc/resources/docbook-xsl/manpage.xsl)","")
+MANPAGEXSL?=$(wildcard /usr/lib/python*/*/asciidoc/resources/docbook-xsl/manpage.xsl)
+else
+MANPAGEXSL?=/usr/share/asciidoc/docbook-xsl/manpage.xsl
+endif
 
 all: build
 
@@ -19,11 +33,16 @@
 	mkdir -p $(DESTDIR)$(MANDIR)/man7
 	mkdir -p $(DESTDIR)$(MANDIR)/man8
 	mkdir -p $(DESTDIR)$(BINDIR)
+	mkdir -p $(DESTDIR)$(LIBEXECDIR)
+	mkdir -p $(DESTDIR)$(UNITDIR)
 	install -p -m 644 $(MAN7PAGES) $(DESTDIR)$(MANDIR)/man7
 	install -p -m 644 $(MAN8PAGES) $(DESTDIR)$(MANDIR)/man8
 	install -p -m 755 $(SCRIPTS) $(DESTDIR)$(BINDIR)
+	install -p -m 644 $(UNITS) $(DESTDIR)$(UNITDIR)
+	install -p -m 755 $(LIBEXEC_SCRIPTS) $(DESTDIR)$(LIBEXECDIR)
 	mkdir -p $(DESTDIR)$(DIR)/
 	install -p -m 644 default-config $(DESTDIR)$(DIR)
+	install -p -m 644 default-fips-config $(DESTDIR)$(DIR)
 	install -p -m 644 output/reload-cmds.sh $(DESTDIR)$(DIR)
 	for f in $$(find output -name '*.txt') ; do d=$$(dirname $$f | cut -f 2- -d '/')  ; install -p -m 644 -D -t $(DESTDIR)$(DIR)/$$d $$f ; done
 	for f in $$(find policies -name '*.p*') ; do d=$$(dirname $$f)  ; install -p -m 644 -D -t $(DESTDIR)$(DIR)/$$d $$f ; done
@@ -31,26 +50,93 @@
 	chmod 755 $(DESTDIR)$(DIR)/python/update-crypto-policies.py
 	chmod 755 $(DESTDIR)$(DIR)/python/build-crypto-policies.py
 
+runruff:
+	ruff check
+
+runflake8:
+	@find -name '*.py' | grep -v krb5check | xargs flake8 --config .flake8
+
+runpylint:
+	PYTHONPATH=. pylint$(PYVERSION) --rcfile=pylintrc python
+	PYTHONPATH=. pylint$(PYVERSION) --rcfile=pylintrc tests
+	@echo "[ OK ]"
+
+runcodespell:
+	codespell -L gost,anull,bund -S .git,./tests/krb5check/*,*.7,*.8
+
 check:
-	python/build-crypto-policies.py --test --flat policies tests/outputs
-	tests/openssl.pl
-	tests/gnutls.pl
-	tests/nss.pl
-	tests/java.pl
+	@mkdir -p output/compare
+	python/build-crypto-policies.py --strict --test --flat policies tests/outputs
+	python/build-crypto-policies.py --strict --policy FIPS:OSPP --test --flat policies tests/outputs
+	python/build-crypto-policies.py --strict --policy FIPS:ECDHE-ONLY --test --flat policies tests/outputs
+	python/build-crypto-policies.py --strict --policy FIPS:NO-ENFORCE-EMS --test --flat policies tests/outputs
+	python/build-crypto-policies.py --strict --policy DEFAULT:GOST --test --flat policies tests/outputs
+	python/build-crypto-policies.py --strict --policy GOST-ONLY --test --flat policies tests/outputs
+	python/build-crypto-policies.py --strict --policy LEGACY:AD-SUPPORT --test --flat policies tests/outputs
+	python/build-crypto-policies.py --strict --policy DEFAULT:NO-PQ --test --flat policies tests/outputs
+	python/build-crypto-policies.py --policy DEFAULT:TEST-PQ --test --flat policies tests/outputs  # not strict
+	# FEDORA43 === DEFAULT
+	diff policies/FEDORA43.pol policies/DEFAULT.pol
+	# FEDORA43:NO-PQ == FEDORA42 == FEDORA43:TEST-PQ:NO-PQ
+	#mkdir -p output/compare/FEDORA43:NO-PQ output/compare/FEDORA42
+	python/build-crypto-policies.py --strict --policy FEDORA43:NO-PQ policies output/compare
+	python/build-crypto-policies.py --policy FEDORA43:TEST-PQ:NO-PQ policies output/compare  # not strict
+	python/build-crypto-policies.py --strict --policy FEDORA42 policies output/compare
+	diff -r output/compare/FEDORA43:NO-PQ output/compare/FEDORA42
+	diff -r output/compare/FEDORA43:TEST-PQ:NO-PQ output/compare/FEDORA42
+	rm -r output/compare
+	tests/openssl.py
+	tests/gnutls.py
+	tests/nss.py
+	tests/java.py
 	tests/krb5.py
 	top_srcdir=. tests/update-crypto-policies.sh
 
+# Alternative, equivalent ways to write the same policies
+check-alternatives: check
+	@rm -rf output/alt
+	@mkdir -p output
+	cp -r tests/outputs output/alt
+	python/build-crypto-policies.py --test --flat tests/alternative-policies output/alt
+	python/build-crypto-policies.py --policy FIPS:OSPP --test --flat tests/alternative-policies output/alt
+	python/build-crypto-policies.py --policy FIPS:ECDHE-ONLY --test --flat tests/alternative-policies output/alt
+	python/build-crypto-policies.py --policy FIPS:NO-ENFORCE-EMS --test --flat tests/alternative-policies output/alt
+	python/build-crypto-policies.py --policy GOST-ONLY --test --flat tests/alternative-policies output/alt
+	python/build-crypto-policies.py --policy LEGACY:AD-SUPPORT --test --flat tests/alternative-policies output/alt
+	python/build-crypto-policies.py --policy DEFAULT:GOST --test --flat tests/alternative-policies output/alt
+	python/build-crypto-policies.py --policy DEFAULT:TEST-PQ --test --flat tests/alternative-policies output/alt
+	@rm -rf output/alt
+
+doctest:
+	@python3 -Werror -m pytest -vv --doctest-modules python/
+
+unittest:
+	@python3 -Werror -m pytest -vv tests/unit/
+
+covtest: #doctest unittest
+	@# FIXME: only covers python/cryptopolicies/ files so far
+	@# NOTE: doesn't grasp ternaries and short-circuiting operators
+	# Don't trust coverage testing
+	PYTHONPATH=. coverage run --source python/cryptopolicies/ --branch -m pytest -vv --doctest-modules python/
+	PYTHONPATH=. coverage run --append --source python/cryptopolicies/ --branch -m pytest -vv tests/unit/
+	coverage report --fail-under=100
+
+test: doctest unittest check check-alternatives
+ifndef SKIP_LINTING
+test: covtest runruff runcodespell runflake8 runpylint
+endif
+
 reset-outputs:
 	@rm -rf tests/outputs/*
-	echo "Outputs were reset. Run make check to re-generate, and commit the output."
+	@echo "Outputs were reset. Run make check to re-generate, and commit the output."
 
 clean:
 	rm -f $(MAN7PAGES) $(MAN8PAGES) *.?.xml
 	rm -rf output
 
 %: %.txt
-	asciidoc.py -v -d manpage -b docbook $<
-	xsltproc --nonet -o $@ /usr/share/asciidoc/docbook-xsl/manpage.xsl $@.xml
+	$(ASCIIDOC) -v -d manpage -b docbook $<
+	$(XSLTPROC) --nonet -o $@ ${MANPAGEXSL} $@.xml
 
 dist:
 	rm -rf crypto-policies && git clone . crypto-policies && rm -rf crypto-policies/.git/ && tar -czf crypto-policies-git$(VERSION).tar.gz crypto-policies && rm -rf crypto-policies
@@ -69,6 +155,3 @@
 	ls -l $(CONFDIR)/back-ends/ | grep -q $$test_policy && exit 3 ; \
 	ls -l $(CONFDIR)/back-ends/ | grep -q $$current_policy || exit $$? ; \
 	update-crypto-policies --is-applied | grep -q "is applied" || exit $$?
-
-test-fips-setup:
-	CONFDIR=$(CONFDIR) ./tests/test-fips-setup.sh

=== debian/changelog ===
crypto-policies (20251128.git19878fe-0ubuntu2) resolute; urgency=medium

  * Update control to specify Architectures as "all"
  * Restructure patches for separation of concern

 -- Simon Johnsson <simon.johnsson@canonical.com>  Wed, 25 Feb 2026 09:59:12 +0100

crypto-policies (20251128.git19878fe-0ubuntu1) resolute; urgency=medium

  * Initial release. (LP: #2138940)
  * Import 20251128.git19878fe from upstream

 -- Simon Johnsson <simon.johnsson@canonical.com>  Wed, 28 Jan 2026 12:27:09 +0100

=== debian/control ===
Source: crypto-policies
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Section: utils
Priority: optional
Standards-Version: 4.7.2
Build-Depends: debhelper-compat (= 13),
               dh-python,
               asciidoc,
               default-jdk,
               gnutls-bin,
               python3,
               python3-coverage,
               python3-pytest

Package: crypto-policies
Architecture: all
Depends: python3, ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Description: crypto-policies - system-wide crypto policies overview
 The security of cryptographic components of the operating system does not
 remain constant over time. Algorithms, such as cryptographic hashing and
 encryption, typically have a lifetime, after which they are considered either
 too risky to use or plain insecure. That means, we need to phase out such
 algorithms from the default settings or completely disable them if they could
 cause an irreparable problem.
 .
 While in the past the algorithms were not disabled in a consistent way and
 different applications applied different policies, the system-wide
 crypto-policies followed by the crypto core components allow consistently
 deprecating and disabling algorithms system-wide.
 .
 The individual policy levels (DEFAULT, LEGACY, and FUTURE) are included
 in the crypto-policies(7) package. In the future, there will be also a
 mechanism for easy creation and deployment of policies defined by the system
 administrator or a third party vendor.
 .
 For rationale, see RFC 7457 for a list of attacks taking advantage of legacy
 crypto algorithms.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --with python3

override_dh_auto_install:
	dh_auto_install -- DESTDIR=$$(pwd)/debian/crypto-policies prefix=/usr

override_dh_auto_test:
	dh_auto_test --no-parallel

=== debian/tests/control ===
Tests: test-kerberos
Depends: bats, bats-assert, krb5-admin-server, krb5-kdc, make, @
Restrictions: needs-root

Tests: test-openssl
Depends: bats, bats-assert, make, openssl, @
Restrictions: needs-root

Tests: test-openssh
Depends: bats, bats-assert, make, openssh-client, openssh-server, @
Restrictions: needs-root

Tests: test-resilience
Depends: bats, bats-assert, make, python3, @
Restrictions: needs-root

Tests: test-upstream
Depends: asciidoc,
         default-jdk,
         gnutls-bin,
         make,
         openssh-client,
         openssh-server,
         python3,
         python3-coverage,
         python3-pytest,
         @
Restrictions: needs-root allow-stderr

=== debian/watch ===
Version: 5
Source: https://gitlab.com/redhat-crypto/fedora-crypto-policies
Compression: gz
Repack: yes
Matching-Pattern: HEAD
Mode: git
Git-Pretty: %cd.git%h
